# Interface ReqDebug

public interface ReqDebug
The signaling interface that allows comprehensive analysis of the ReqSketch and ReqCompactor while eliminating code clutter in the main classes. The implementation of this interface can be found in the test tree.

Author:
  Lee Rhodes

## Method Summary

Modifier and Type
Method
Description
`void`
`emitAdjSecSizeNumSec(byte lgWeight)`
Emit adjusting section size and number of sections.
`void`
`emitAllHorizList()`
Emit all horizontal lists
`void`
`emitCompactingStart(byte lgWeight)`
Emit Compaction Start.
`void`
`emitCompactionDetail(int compactionStart, int compactionEnd, int secsToCompact, int promoteLen, boolean coin)`
Emit Compaction details.
`void`
`emitCompactionDone(byte lgWeight)`
Emit compaction done and number of compactions so far.
`void`
`emitCompressDone()`
Emit compress done.
`void`
`emitMustAddCompactor()`
Emit Must add compactor
`void`
`emitNewCompactor(byte lgWeight)`
Emit new compactor configuration
`void`
`emitStart(ReqSketch sk)`
Emit the start signal
`void`
`emitStartCompress()`
Emit Start Compress

## Method Details

### emitStart

void emitStart(ReqSketch sk)
Emit the start signal

Parameters:
  `sk` - the sketch

### emitStartCompress

void emitStartCompress()
Emit Start Compress

### emitCompressDone

void emitCompressDone()
Emit compress done.

### emitAllHorizList

void emitAllHorizList()
Emit all horizontal lists

### emitMustAddCompactor

void emitMustAddCompactor()
Emit Must add compactor

### emitCompactingStart

void emitCompactingStart(byte lgWeight)
Emit Compaction Start.

Parameters:
  `lgWeight` - compactor lgWeight or height

### emitNewCompactor

void emitNewCompactor(byte lgWeight)
Emit new compactor configuration

Parameters:
  `lgWeight` - the log weight

### emitAdjSecSizeNumSec

void emitAdjSecSizeNumSec(byte lgWeight)
Emit adjusting section size and number of sections.

Parameters:
  `lgWeight` - the log weight

### emitCompactionDetail

void emitCompactionDetail(int compactionStart, int compactionEnd, int secsToCompact, int promoteLen, boolean coin)
Emit Compaction details.

Parameters:
  `compactionStart` - the offset of compaction start
  `compactionEnd` - the offset of compaction end
  `secsToCompact` - the number of sections to compact
  `promoteLen` - the length of the promotion field
  `coin` - the state of the random coin.

### emitCompactionDone

void emitCompactionDone(byte lgWeight)
Emit compaction done and number of compactions so far.

Parameters:
  `lgWeight` - the log weight